Sign in

Get started with a SuperDoc DOCX editor using Liveblocks and React

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the APIs from the @liveblocks/yjs package, and SuperDoc, a collaborative DOCX editor for the web.

Quickstart

  1. Install Liveblocks, Yjs, and SuperDoc

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/react @liveblocks/yjs yjs @superdoc-dev/react
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework react
  3. Set up the Liveblocks client

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate, and to create a realtime experience, multiple users must be connected to the same room. Set up a Liveblocks client with LiveblocksProvider, and join a room with RoomProvider.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> {/* ... */} </RoomProvider> </LiveblocksProvider> );}
  4. Join a Liveblocks room

    After setting up the room, you can add collaborative components inside it, using ClientSideSuspense to add loading spinners to your app.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider, ClientSideSuspense,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> <ClientSideSuspense fallback={<div>Loading…</div>}> <Editor /> </ClientSideSuspense> </RoomProvider> </LiveblocksProvider> );}
  5. Set up the collaborative SuperDoc editor

    Now that we set up Liveblocks, we can start integrating SuperDoc and Yjs in the Editor.tsx file. We use getYjsProviderForRoom to get a Yjs document and provider, then pass them to the <SuperDocEditor /> component through modules.collaboration. The component handles mounting, cleanup, and SSR for you. It rebuilds when modules changes, so we memoize it.

    Editor.tsx
    "use client";
    import { useMemo } from "react";import { getYjsProviderForRoom } from "@liveblocks/yjs";import { useRoom, useSelf } from "@liveblocks/react/suspense";import { SuperDocEditor } from "@superdoc-dev/react";import "@superdoc-dev/react/style.css";
    // Collaborative DOCX editor with live cursors, powered by SuperDocexport function Editor() { const room = useRoom(); const yProvider = getYjsProviderForRoom(room);
    // Get the current user's info from Liveblocks const userInfo = useSelf((me) => me.info); const userId = useSelf((me) => me.id);
    const modules = useMemo( () => ({ // The collaboration contract is the same for every Yjs provider: // pass the shared `ydoc` and `provider` collaboration: { ydoc: yProvider.getYDoc(), provider: yProvider }, }), [yProvider] );
    return ( <div style={{ height: "100vh" }}> <SuperDocEditor documentMode="editing" // Identify the current user for live cursors user={{ email: userId, name: userInfo?.name ?? "Anonymous", image: userInfo?.avatar ?? undefined, }} modules={modules} style={{ height: "100%" }} /> </div> );}
  6. Next: authenticate and add your users

    Text Editor is set up and working now, but each user is anonymous—the next step is to authenticate each user as they connect, and attach their name, color, and avatar, to their cursors and mentions.

    Add your users to Text Editor

What to read next

Congratulations! You now have set up the foundation for your collaborative SuperDoc DOCX editor inside your React application.


Examples using SuperDoc

Sign in

Get started with a SuperDoc DOCX editor using Liveblocks and Vue.js

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/yjs package, and SuperDoc, a collaborative DOCX editor for the web.

Quickstart

  1. Install Liveblocks, Yjs, and SuperDoc

    Every Liveblocks package should use the same version.

    Terminal
    npm install @liveblocks/client @liveblocks/yjs yjs superdoc
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    Terminal
    npx create-liveblocks-app@latest --init --framework javascript
  3. Set up your collaborative SuperDoc editor

    SuperDoc relies on browser APIs, so we wait for the provider’s first sync before mounting the editor, and pass the shared ydoc and provider to SuperDoc through modules.collaboration.

    Editor.vue
    <script setup>import { onMounted, onUnmounted } from "vue";import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import { SuperDoc } from "superdoc";import "superdoc/style.css";
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst { room, leave } = client.enterRoom("my-room");
    // Set up Yjs document and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();
    let superdoc = null;
    function initSuperDoc() { // Get the current user's info from Liveblocks const { id, info } = room.getSelf();
    superdoc = new SuperDoc({ selector: "#superdoc", toolbar: "#superdoc-toolbar", documentMode: "editing", user: { email: id, name: info?.name ?? "Anonymous", image: info?.avatar ?? undefined, }, modules: { // The collaboration contract is the same for every Yjs provider: // pass the shared `ydoc` and `provider` collaboration: { ydoc: yDoc, provider: yProvider }, }, });}
    onMounted(() => { // Wait for the initial sync so the document isn’t created twice if (yProvider.synced) { initSuperDoc(); } else { yProvider.on("sync", initSuperDoc); }});
    onUnmounted(() => { superdoc?.destroy?.(); leave();});</script>
    <template> <div id="superdoc-toolbar" /> <div id="superdoc" style="height: 700px" /></template>
  4. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative SuperDoc DOCX editor inside your Vue.js application.